/// <reference types="node" />
import { OrderOption } from '@tryghost/bookshelf-repository';
import { AddRecommendation, Recommendation } from './Recommendation';
import { RecommendationRepository } from './RecommendationRepository';
import { WellknownService } from './WellknownService';
type MentionSendingService = {
    sendAll(options: {
        url: URL;
        links: URL[];
    }): Promise<void>;
};
type RecommendationEnablerService = {
    getSetting(): string;
    setSetting(value: string): Promise<void>;
};
export declare class RecommendationService {
    repository: RecommendationRepository;
    wellknownService: WellknownService;
    mentionSendingService: MentionSendingService;
    recommendationEnablerService: RecommendationEnablerService;
    constructor(deps: {
        repository: RecommendationRepository;
        wellknownService: WellknownService;
        mentionSendingService: MentionSendingService;
        recommendationEnablerService: RecommendationEnablerService;
    });
    init(): Promise<void>;
    updateWellknown(recommendations: Recommendation[]): Promise<void>;
    updateRecommendationsEnabledSetting(recommendations: Recommendation[]): Promise<void>;
    private sendMentionToRecommendation;
    addRecommendation(addRecommendation: AddRecommendation): Promise<Recommendation>;
    editRecommendation(id: string, recommendationEdit: Partial<Recommendation>): Promise<Recommendation>;
    deleteRecommendation(id: string): Promise<void>;
    listRecommendations({ page, limit, filter, order }?: {
        page: number;
        limit: number | 'all';
        filter?: string;
        order?: OrderOption<Recommendation>;
    }): Promise<Recommendation[]>;
    countRecommendations({ filter }: {
        filter?: string;
    }): Promise<number>;
}
export {};
